// StudentMazeGenerator.java
//
// ICS 23 Project #1: Dark at the End of the Tunnel
// Coded by Alex Thornton Fall 2002


// The StudentMazeGenerator class is where you should implement your maze
// generation algorithm. Presently, it returns a newly-created maze in which
// every wall exists.

import java.util.Random;
import java.util.Set;
import java.util.HashSet;


public class StudentMazeGenerator implements MazeGenerator
{
    private Random random = new Random();
    
    private Set visited;
    
    protected Maze maze;
    protected MazeGeneratorListener listener;
    
    public Maze generateMaze(int width, int height, MazeGeneratorListener listener)
    {
        maze = MazeFactory.createMaze(width, height);
        (this.listener = listener).startingMazeGeneration(maze);
        visited = new HashSet();
        
        generateMaze(new NNode(0, 0));
        return maze;
    }
    
    
    public void generateMaze(NNode current) {
        // Aufbabencode hier einfuegen.
    }
    

    private void printMaze(Maze maze, java.io.PrintStream output)
    {
        for (int x = 0; x < maze.getWidth(); x++) {
            output.print(" _");
        }
        output.println();
        
        for (int y = 0; y < maze.getHeight(); y++) {
            if (!maze.canMoveWestFrom(0, y)) {
                output.print('|');
            }
            for (int x = 0; x < maze.getWidth(); x++) {
                if (!maze.canMoveSouthFrom(x, y)) {
                    output.print('_');
                }
                else {
                    output.print(' ');
                }
                
                if (!maze.canMoveEastFrom(x, y)) {
                    output.print('|');
                }
                else {
                    output.print(' ');
                }
            }
            output.println();
        }
    }
}


class NNode {
    private int x;
    private int y;
    
    public NNode(int x, int y) {
        this.x = x;
        this.y = y;
    }
    
    public int getX() { return x; }
    
    public int getY() { return y; }
    
    public boolean equals(Object o) {
        if (o == null || !(o instanceof NNode)) return false;
        
        NNode node = (NNode) o;
        
        return node.getX() == getX() && node.getY() == getY();
    }
    
    
    public int hashCode() {
        return x + 100 * y;
    }
    
    
    public String toString() {
        return "Node: (" + x + ", " + y + ")";
    }
}
